<!DOCTYPE html>
<html>
<head>
  <link href="https://fonts.googleapis.com/css?family=Roboto:100,300,400,500,700,900" rel="stylesheet">
  <link href="https://cdn.jsdelivr.net/npm/@mdi/font@4.x/css/materialdesignicons.min.css" rel="stylesheet">
  <link href="https://cdn.jsdelivr.net/npm/vuetify@2.x/dist/vuetify.min.css" rel="stylesheet">
  <meta name="viewport" content="width=device-width, initial-scale=1, maximum-scale=1, user-scalable=no, minimal-ui">
  <style>
    pre {
      background-color: #292929;
      color: #fafafa;
      font-size: smaller;
      overflow: auto;
    }
  </style>
  <title>Action Browser</title>
</head>
<body>
  {% csrf_token %}
  <div id="app">
    <v-app>
        <v-navigation-drawer dark permanent v-model="drawer" app >
            <v-list dense>
              <v-subheader >Resources</v-subheader>
              {% for resource in resources %}
              <v-list-item @click='fetchActions("{{resource.name}}", "{{resource.path}}")'>
                  <v-list-item-content>
                      <v-list-item-title>{{resource.name}}</v-list-item-title>
                  </v-list-item-content>
              </v-list-item >
              {% endfor %}
            </v-list>
        </v-navigation-drawer>
        <v-app-bar app dense flat  >
            <v-toolbar-title>Application</v-toolbar-title>
        </v-app-bar>
      <v-content>
        <v-container>
          <v-list >
            <v-subheader class='overline' >[[selectedResource]]</v-subheader>
            <v-divider></v-divider>
            <v-subheader class='overline' >Bulk actions</v-subheader>
            <template v-for='action in actions.bulk_actions' >
              <v-list-item
                :key='action.name'
                @click='selectedAction = action' >
                <v-list-item-content>
                  <v-list-item-title>
                    [[action.title]]
                    <v-chip class='ml-2' x-small outlined color='primary' >
                      Version: [[action.version]]
                    </v-chip>
                    <v-chip class='ml-2' x-small outlined color='primary' >
                      Status: <span class='text-uppercase'>[[action.status]]</span>
                    </v-chip>
                  </v-list-item-title>
                  <v-list-item-subtitle >
                    [[action.description]]
                  </v-list-item-subtitle >
                </v-list-item-content>
              </v-list-item>
              <v-divider :key='div-`${action.id}`'></v-divider>
            </template>
            <v-subheader class='overline mt-3' >Instance actions</v-subheader>
            <template v-for='action in actions.instance_actions' >
              <v-list-item
                :key='action.name'
                @click='selectedAction = action' >
                <v-list-item-content>
                  <v-list-item-title>
                    [[action.title]]
                    <v-chip class='ml-2' x-small outlined color='primary' >
                      Version: [[action.version]]
                    </v-chip>
                    <v-chip class='ml-2' x-small outlined color='primary' >
                      Status: <span class='text-uppercase'>[[action.status]]</span>
                    </v-chip>
                  </v-list-item-title>
                  <v-list-item-subtitle >
                    [[action.description]]
                  </v-list-item-subtitle >
                </v-list-item-content>
              </v-list-item>
              <v-divider :key='div-`${action.id}`'></v-divider>
            </template>
          </v-list>
          <v-navigation-drawer permanent app right width='600' v-model="showSideBar" >
            <v-tabs v-model='activeTab' >
              <v-tab >Docs</v-tab>
              <v-tab >Play</v-tab>
              <v-tab >Raw</v-tab>
              <v-tabs-items v-model='activeTab' >
                <v-tab-item >
                  <v-card flat v-if='selectedAction'>
                    <v-card-title class='subtitle-1' >
                      [[selectedAction.title]]
                    </v-card-title>
                    <v-card-text>
                      [[selectedAction.description]]
                    </v-card-text>
                    <v-subheader>Spec</v-subheader>
                    <v-list v-if='selectedAction.capabilities' dense >
                      <v-list-item v-for='capability in selectedAction.capabilities' >
                        <v-list-item-action >
                          <v-icon v-if='capability.done' >mdi-check</v-icon>
                          <v-icon v-if='capability.done' >mdi-dot</v-icon>
                        </v-list-item-action >
                        <v-list-item-content>
                          <v-list-item-title>[[capability.title]]</v-list-item-title>
                        </v-list-item-content>
                      </v-list-item>
                    </v-list>
                    <v-subheader>Commands</v-subheader>
                    <v-card flat v-for='command in selectedAction.commands' >
                    <v-subheader class='overline' >[[command.name]]</v-subheader>
                    <pre class='mx-3 pa-3'>[[command.command]]</pre>
                    </v-card>

                  </v-card>
                </v-tab-item>
                <v-tab-item >
                  <v-form v-if='selectedAction' >
                    <v-card flat >
                      <v-card-title class='overline' >
                        Try it out
                      </v-card-title>
                      <v-card-text>
                        <v-text-field
                          v-model='instancePK'
                          v-if='selectedAction.type === "instance"'
                          label='Provide the ID of an instance' >
                        </v-text-field>
                        <v-text-field
                          v-model='instancePKs'
                          v-if='selectedAction.type === "bulk"'
                          label='Provide a comma seperated list of IDs' >
                        </v-text-field>
                        <v-textarea
                          v-model='payload'
                          filled label='Payload' ></v-textarea>
                      </v-card-text>
                      <v-card-actions >
                        <v-select
                          dense outlined small hide-details
                          v-model='selectedExample'
                          :items='selectedAction.examples'
                          item-text='name'
                          return-object
                          label='Pick a scenario'
                          class='mx-3 mt-1' >
                        </v-select >
                        <v-spacer></v-spacer>
                        <v-btn @click='performAction' >
                          Submit
                        </v-btn>
                      </v-card-actions>
                      <v-tabs v-model='requestActiveTab' v-if='actionResponse' >
                        <v-tab >Request</v-tab>
                        <v-tab >Response</v-tab>
                        <v-tabs-items v-model='requestActiveTab' >
                          <v-tab-item >
                            <v-subheader class='overline' >
                              Request
                            </v-subheader>
                            <pre>POST [[actionUrl]]</pre>
                            <v-subheader class='overline' >Headers</v-subheader>
                            <pre >[[actionHeaders]]</pre>
                            <v-subheader class='overline' >Payload</v-subheader>
                            <pre >[[payload]]</pre>
                          </v-tab-item>
                          <v-tab-item >
                            <v-subheader class='overline' >
                              Response
                              <v-spacer></v-spacer>
                              <v-chip small color='success' v-if='actionResponse.status < 300' >[[actionResponse.status]]</v-chip>
                              <v-chip small color='error' v-if='actionResponse.status >= 300' >[[actionResponse.status]]</v-chip>
                            </v-subheader>
                            <v-subheader class='overline' >Data</v-subheader>
                            <pre >[[actionResponse.data]]</pre>
                            <v-subheader class='overline' >Headers</v-subheader>
                            <pre >[[actionResponse.headers]]</pre>
                          </v-tab-item>
                        </v-tabs-items>
                      </v-tabs>
                    </v-card>

                  </v-form>
                </v-tab-item>
                <v-tab-item >
                  <pre>[[selectedAction]]</pre>
                </v-tab-item>
              </v-tabs-items>
            </v-tabs>

          </v-navigation-drawer >
        </v-container>
      </v-content>
    </v-app>
  </div>

  <script src="https://cdn.jsdelivr.net/npm/vue@2.x/dist/vue.js"></script>
  <script src="https://cdn.jsdelivr.net/npm/vuetify@2.x/dist/vuetify.js"></script>
  <script src="https://cdn.jsdelivr.net/npm/axios/dist/axios.min.js"></script>
  <script>
    new Vue({
      el: '#app',
      vuetify: new Vuetify(),
      delimiters: ['[[', ']]'],
      data () {
        return {
          drawer: true,
          payload: null,
          selectedExample: null,
          selectedResource: null,
          selectedResourcePath: null,
          selectedAction: null,
          showSideBar: false,
          activeTab: 0,
          requestActiveTab: 0,
          actions: [],
          instancePK: 1,
          actionResponse: null
        }
      },
      methods: {
        async fetchActions (resourceName, resourcePath) {
          this.selectedResource = resourceName
          this.selectedResourcePath = resourcePath
          let path = `${resourcePath}actions/list/`
          let result = await axios.get(path)
          if (result.status === 200) {
            this.actions = result.data
          }
        },
        async performAction () {
          let url = this.actionUrl
          let data = JSON.parse(this.payload)
          let headers = this.actionHeaders
          let options = {
            url,
            data,
            headers,
            method: 'POST'
          }
          axios(options)
            .then((result) => {
              this.actionResponse = {
                status: result.status,
                data: result.data,
                headers: result.headers
              }
              this.requestActiveTab = 1
            })
            .catch((err) => {
              let result = err.response
              this.actionResponse = {
                status: result.status,
                data: result.data,
                headers: result.headers
              }
              this.requestActiveTab = 1
            })
        }
      },
      computed: {
        actionHeaders () {
          let csrf_token = document.getElementsByName('csrfmiddlewaretoken')[0].value
          return {
            'ContentType': 'application/json',
            'X-CSRFToken': csrf_token
          }
        },
        actionUrl () {
          if (this.selectedResource && this.selectedAction) {
            if (this.selectedAction.type === "instance") {
              return `${this.selectedResourcePath}${this.instancePK}/actions/${this.selectedAction.id}/`
            } else {
              return `${this.selectedResourcePath}actions/${this.selectedAction.id}/`
            }
          }
        }
      },
      watch: {
        selectedExample () {
          this.payload = JSON.stringify(this.selectedExample.payload)
        },
        selectedAction () {
          if (this.selectedAction) {
            this.payload = JSON.stringify(this.selectedAction.example_payload)
            this.actionResponse = null
          }
        }
      }
    })
  </script>
</body>
</html>